// 7565_VCDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "7565_VCDemo.h"
#include "7565_VCDemoDlg.h"

#include "msflexgrid.h"
#include "uart.h"
#include "ReceiveThread.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
double SystemFreq;

PacketStruct RxData[MAX_BUFFER];
int NewData=0,OldData=0;
BOOL BusyFlag1=0;
BOOL BusyFlag2=0;
BOOL ClearList=0;
BOOL InitialFlag = 0;
BOOL ThreadFlag=0;

CMSFlexGrid* ms_ReceiveList;
unsigned long static MesgCount=0;
int Scrolling;

BYTE StartReceive=0;
unsigned long TimeOutCnt=0;


DWORD lpIDEvent;
HANDLE TimerHandle;
HANDLE AnalyzeHandle;

BOOL OpenCOMFlag=0;
BYTE* PortTemp;

//Define COM basic variables
static WORD m_ComPort=1;
static WORD m_DataBit=8;
static WORD m_StopBit=0;
static DWORD m_Baudrate=921600L;
static WORD m_Parity=0;
static WORD m_CheckUseCAN=0;
static UINT m_timerint=500;

int CmdIdx=0,ResponseIdx=0;

WORD wt;
static char m_szReceive[2048];
static char m_szSend[1024];
CString SendString_Temp;
CString RecvString_Temp;

void SetTextMatrix(){
	ms_ReceiveList->SetTextMatrix(0,0,"NO.");
	ms_ReceiveList->SetTextMatrix(0,1,"Mode");
	ms_ReceiveList->SetTextMatrix(0,2,"ID");
	ms_ReceiveList->SetTextMatrix(0,3,"RTR");
	ms_ReceiveList->SetTextMatrix(0,4,"L");
	ms_ReceiveList->SetTextMatrix(0,5,"D0");
	ms_ReceiveList->SetTextMatrix(0,6,"D1");
	ms_ReceiveList->SetTextMatrix(0,7,"D2");
	ms_ReceiveList->SetTextMatrix(0,8,"D3");
	ms_ReceiveList->SetTextMatrix(0,9,"D4");
	ms_ReceiveList->SetTextMatrix(0,10,"D5");
	ms_ReceiveList->SetTextMatrix(0,11,"D6");
	ms_ReceiveList->SetTextMatrix(0,12,"D7");
	//ms_ReceiveList->SetTextMatrix(0,13,"Time Stamps(s)");
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy7565_VCDemoDlg dialog

CMy7565_VCDemoDlg::CMy7565_VCDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy7565_VCDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMy7565_VCDemoDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy7565_VCDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMy7565_VCDemoDlg)
	DDX_Control(pDX, IDC_BUTTON_Clear, m_Clear);
	DDX_Control(pDX, IDC_BUTTON_Set, m_SetTimer);
	DDX_Control(pDX, IDC_EDIT_TIME, m_timer);
	DDX_Control(pDX, IDC_EDIT_SendMsg, m_EditSendMsg);
	DDX_Control(pDX, IDC_CHECK_UseCAN, m_CheckBoxUseCAN);
	DDX_Control(pDX, IDC_BUTTON_Auto, m_auto);
	DDX_Control(pDX, IDC_BUTTON_Stop, m_stop);
	DDX_Control(pDX, IDC_BUTTON_Send, m_send);
	DDX_Control(pDX, IDC_BUTTON_STARTRECE, m_startrece);
	DDX_Control(pDX, IDC_BUTTON_STOPRECE, m_stoprece);
	DDX_Control(pDX, IDC_COMBO5, m_ComboStopBit);
	DDX_Control(pDX, IDC_BUTTON_CloseCOM, m_BtnCloseCom);
	DDX_Control(pDX, IDC_BUTTON_OpenCOM, m_BtnOpenCom);
	DDX_Control(pDX, IDC_COMBO4, m_ComboParity);
	DDX_Control(pDX, IDC_COMBO2, m_ComboBaudrate);
	DDX_Control(pDX, IDC_COMBO3, m_ComboDataBit);
	DDX_Control(pDX, IDC_COMBO1, m_ComboComPort);
	DDX_Control(pDX, IDC_EDIT_RTR, m_rtr);
	DDX_Control(pDX, IDC_EDIT_MODE, m_mode);
	DDX_Control(pDX, IDC_EDIT_ID, m_id);
	DDX_Control(pDX, IDC_EDIT_DLEN, m_dlen);
	DDX_Control(pDX, IDC_EDIT_D7, m_d7);
	DDX_Control(pDX, IDC_EDIT_D6, m_d6);
	DDX_Control(pDX, IDC_EDIT_D5, m_d5);
	DDX_Control(pDX, IDC_EDIT_D4, m_d4);
	DDX_Control(pDX, IDC_EDIT_D3, m_d3);
	DDX_Control(pDX, IDC_EDIT_D2, m_d2);
	DDX_Control(pDX, IDC_EDIT_D1, m_d1);
	DDX_Control(pDX, IDC_EDIT_D0, m_d0);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy7565_VCDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CMy7565_VCDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_OpenCOM, OnBUTTONOpenCOM)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeCombo1)
	ON_CBN_SELCHANGE(IDC_COMBO2, OnSelchangeCombo2)
	ON_CBN_SELCHANGE(IDC_COMBO3, OnSelchangeCombo3)
	ON_CBN_SELCHANGE(IDC_COMBO4, OnSelchangeCombo4)
	ON_CBN_SELCHANGE(IDC_COMBO5, OnSelchangeCombo5)
	ON_BN_CLICKED(IDC_BUTTON8, OnButtonClear)
	ON_BN_CLICKED(IDC_BUTTON_STOPRECE, OnButtonStoprece)
	ON_BN_CLICKED(IDC_BUTTON_STARTRECE, OnButtonStartrece)
	ON_BN_CLICKED(IDC_BUTTON_CloseCOM, OnBUTTONCloseCOM)
	ON_BN_CLICKED(IDC_CHECK_UseCAN, OnCHECKUseCAN)
	ON_BN_CLICKED(IDC_BUTTON_Send, OnBUTTONSend)
	ON_EN_CHANGE(IDC_EDIT_ID, OnChangeEditId)
	ON_EN_CHANGE(IDC_EDIT_MODE, OnChangeEditMode)
	ON_EN_CHANGE(IDC_EDIT_RTR, OnChangeEditRtr)
	ON_EN_CHANGE(IDC_EDIT_DLEN, OnChangeEditDlen)
	ON_EN_CHANGE(IDC_EDIT_D0, OnChangeEditD0)
	ON_EN_CHANGE(IDC_EDIT_D1, OnChangeEditD1)
	ON_EN_CHANGE(IDC_EDIT_D2, OnChangeEditD2)
	ON_EN_CHANGE(IDC_EDIT_D3, OnChangeEditD3)
	ON_EN_CHANGE(IDC_EDIT_D4, OnChangeEditD4)
	ON_EN_CHANGE(IDC_EDIT_D5, OnChangeEditD5)
	ON_EN_CHANGE(IDC_EDIT_D6, OnChangeEditD6)
	ON_EN_CHANGE(IDC_EDIT_D7, OnChangeEditD7)
	ON_BN_CLICKED(IDC_BUTTON_Auto, OnBUTTONAuto)
	ON_BN_CLICKED(IDC_BUTTON_Stop, OnBUTTONStop)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_Set, OnBUTTONSet)
	ON_BN_CLICKED(IDC_RADIO_SCROLL, OnRadioScroll)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy7565_VCDemoDlg message handlers

BSTR bstrLicense;

BOOL CMy7565_VCDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	int j;
	CRect ListRect;
	LARGE_INTEGER litmp;


	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	//Initial COM Parameters
	m_ComboComPort.SetCurSel(0);
	m_ComboBaudrate.SetCurSel(10);
	m_ComboDataBit.SetCurSel(3);
	m_ComboParity.SetCurSel(0);
	m_ComboStopBit.SetCurSel(0);
	
	m_BtnOpenCom.EnableWindow(true);
	m_BtnCloseCom.EnableWindow(false);

	m_CheckBoxUseCAN.EnableWindow(false);
	m_CheckBoxUseCAN.SetCheck(1);
	m_auto.EnableWindow(false);
	m_stop.EnableWindow(false);
	m_send.EnableWindow(false);
	m_SetTimer.EnableWindow(false);
	m_EditSendMsg.EnableWindow(false);

	m_mode.EnableWindow(false);
	m_id.EnableWindow(false);
	m_rtr.EnableWindow(false);
	m_dlen.EnableWindow(false);
	m_d0.EnableWindow(false);
	m_d1.EnableWindow(false);
	m_d2.EnableWindow(false);
	m_d3.EnableWindow(false);
	m_d4.EnableWindow(false);
	m_d5.EnableWindow(false);
	m_d6.EnableWindow(false);
	m_d7.EnableWindow(false);
	m_timer.EnableWindow(false);

	m_Clear.EnableWindow(false);
	m_stoprece.EnableWindow(false);
	m_startrece.EnableWindow(false);

	m_radio_scroll = new CButton;
    ms_ReceiveList = new CMSFlexGrid;

	CFont *pFont = new CFont();

	pFont->CreateFont(16, 5, 0,0,FW_NORMAL, 0, 0, 0, ANSI_CHARSET,
		OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
		DEFAULT_PITCH|FF_DONTCARE, "Century");

	
	ListRect.left = 200;
	ListRect.right = 265;
	ListRect.top = 398;
	ListRect.bottom = 419;

	m_radio_scroll->Create("Scrolling",WS_VISIBLE|BS_AUTOCHECKBOX|BS_PUSHLIKE
		,ListRect,this,IDC_RADIO_SCROLL);
	m_radio_scroll->SetFont(pFont,TRUE);
	m_radio_scroll->SetCheck(1);
	Scrolling = m_radio_scroll->GetCheck();
	m_radio_scroll->ShowWindow(SW_SHOW);
	m_radio_scroll->EnableWindow(false);


	QueryPerformanceFrequency(&litmp);
	SystemFreq = (double)litmp.QuadPart;

	ListRect.left = 18;
	ListRect.right = 584;
	ListRect.top = 250;
	ListRect.bottom = 380;

	//bstrLicense = ::SysAllocStringLen(pwchLicenseKey,
    //   sizeof(pwchLicenseKey)/sizeof(WCHAR)); 
    bstrLicense = ::SysAllocString(L"72E67120-5959-11cf-91F6-C2863C385E30");
	
	
	ms_ReceiveList->Create(NULL, WS_CHILD|WS_VISIBLE|ES_AUTOVSCROLL, ListRect
						, this, IDC_GRID_REST_CAN0,NULL,FALSE,bstrLicense);

	

	ASSERT(ms_ReceiveList->GetSafeHwnd());
	ms_ReceiveList->SetWindowPos(&wndTop,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE);

	ms_ReceiveList->SetCols(14);
	ms_ReceiveList->SetRows(20001);
	ms_ReceiveList->SetColWidth(0,500);
	ms_ReceiveList->SetColWidth(1,585);
	ms_ReceiveList->SetColWidth(2,1050);
	ms_ReceiveList->SetColWidth(3,525);
	ms_ReceiveList->SetColWidth(4,300);
	for(j=5;j<=12;j++){
		ms_ReceiveList->SetColWidth(j,510);
	}
	ms_ReceiveList->SetColWidth(13,1350);

	ms_ReceiveList->SetTextMatrix(0,0,"NO.");
	ms_ReceiveList->SetTextMatrix(0,1,"Mode");
	ms_ReceiveList->SetTextMatrix(0,2,"ID");
	ms_ReceiveList->SetTextMatrix(0,3,"RTR");
	ms_ReceiveList->SetTextMatrix(0,4,"L");
	ms_ReceiveList->SetTextMatrix(0,5,"D0");
	ms_ReceiveList->SetTextMatrix(0,6,"D1");
	ms_ReceiveList->SetTextMatrix(0,7,"D2");
	ms_ReceiveList->SetTextMatrix(0,8,"D3");
	ms_ReceiveList->SetTextMatrix(0,9,"D4");
	ms_ReceiveList->SetTextMatrix(0,10,"D5");
	ms_ReceiveList->SetTextMatrix(0,11,"D6");
	ms_ReceiveList->SetTextMatrix(0,12,"D7");
	//ms_ReceiveList->SetTextMatrix(0,13,"Time Stamps(s)");

	for(j=0;j<13;j++){
		ms_ReceiveList->SetColAlignment(j,4);
	}

	ms_ReceiveList->ShowWindow(SW_SHOW);


	m_mode.LimitText(1);
	m_mode.SetWindowText(_T("0"));
	m_id.LimitText(8);
	m_id.SetWindowText(_T("0"));
	m_rtr.LimitText(1);
	m_rtr.SetWindowText(_T("0"));
	m_dlen.LimitText(1);
	m_dlen.SetWindowText(_T("0"));
	m_d0.LimitText(2);
	m_d0.SetWindowText(_T("00"));
	m_d1.LimitText(2);
	m_d1.SetWindowText(_T("00"));
	m_d2.LimitText(2);
	m_d2.SetWindowText(_T("00"));
	m_d3.LimitText(2);
	m_d3.SetWindowText(_T("00"));
	m_d4.LimitText(2);
	m_d4.SetWindowText(_T("00"));
	m_d5.LimitText(2);
	m_d5.SetWindowText(_T("00"));
	m_d6.LimitText(2);
	m_d6.SetWindowText(_T("00"));
	m_d7.LimitText(2);
	m_d7.SetWindowText(_T("00"));
	m_timer.SetWindowText(_T("500"));
	m_timer.LimitText(5);


	
	if(!InitialFlag)
	{
		PortTemp = new BYTE;
		PortTemp = 0;

		TimerHandle = CreateThread(NULL,0,ReceiveThread,&PortTemp,0,&lpIDEvent);
		AnalyzeHandle = CreateThread(NULL,0,AnalyzeThread,&PortTemp,0,&lpIDEvent);
	}
	
	if(!OpenCOMFlag)
	{
		SuspendThread(TimerHandle);
		SuspendThread(AnalyzeHandle);
		m_stoprece.ShowWindow(SW_SHOW);
		m_startrece.ShowWindow(SW_HIDE);
		m_stoprece.EnableWindow(false);
		m_stoprece.EnableWindow(false);
	}
	else
	{
		ResumeThread(TimerHandle);
		ResumeThread(AnalyzeHandle);
		m_stoprece.ShowWindow(SW_HIDE);
		m_startrece.ShowWindow(SW_SHOW);
		m_stoprece.EnableWindow(true);
		m_stoprece.EnableWindow(true);
	}

	InitialFlag = 1;

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMy7565_VCDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMy7565_VCDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMy7565_VCDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMy7565_VCDemoDlg::OnDestroy() 
{
	DWORD dwExitCode;
	BOOL Result;

	::SysFreeString(bstrLicense); 

	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	GetExitCodeThread(TimerHandle,&dwExitCode);
	TerminateThread(TimerHandle,dwExitCode);
	CloseHandle(TimerHandle);
	GetExitCodeThread(AnalyzeHandle,&dwExitCode);
	TerminateThread(AnalyzeHandle,dwExitCode);
	CloseHandle(AnalyzeHandle);

	KillTimer(200);

	Sleep(500);
	Result=Close_Com((unsigned char)m_ComPort);
}

void CMy7565_VCDemoDlg::OnBUTTONOpenCOM() 
{
	// TODO: Add your control notification handler code here
	WORD Result;
	char test[30];

	//wsprintf(test,"m_Baudrate=%lu",m_Baudrate);
	//MessageBox(test,_T("Message"),NULL);

	Result=Open_Com((unsigned char)m_ComPort, (DWORD)m_Baudrate, (char)m_DataBit, (char)m_Parity, (char)m_StopBit);
	if(Result == 0){
		m_BtnOpenCom.EnableWindow(false);
		m_BtnCloseCom.EnableWindow(true);
		m_ComboComPort.EnableWindow(false);
		m_ComboBaudrate.EnableWindow(false);
		m_ComboDataBit.EnableWindow(false);
		m_ComboParity.EnableWindow(false);
		m_ComboStopBit.EnableWindow(false);

		m_CheckBoxUseCAN.EnableWindow(true);
		m_CheckBoxUseCAN.SetCheck(1);
		m_auto.EnableWindow(true);
		m_stop.EnableWindow(false);
		m_send.EnableWindow(true);
		m_SetTimer.EnableWindow(true);
		m_EditSendMsg.EnableWindow(false);

		m_mode.EnableWindow(true);
		m_id.EnableWindow(true);
		m_rtr.EnableWindow(true);
		m_dlen.EnableWindow(true);
		m_d0.EnableWindow(true);
		m_d1.EnableWindow(true);
		m_d2.EnableWindow(true);
		m_d3.EnableWindow(true);
		m_d4.EnableWindow(true);
		m_d5.EnableWindow(true);
		m_d6.EnableWindow(true);
		m_d7.EnableWindow(true);
		m_timer.EnableWindow(true);
		m_Clear.EnableWindow(true);
		m_stoprece.EnableWindow(true);
		m_startrece.EnableWindow(true);
		m_radio_scroll->EnableWindow(true);

		OpenCOMFlag=1;
		if(InitialFlag)
		{
			ResumeThread(TimerHandle);
			ResumeThread(AnalyzeHandle);
		}
	}
	else
	{
		wsprintf(test,"Open Com%d Error",m_ComPort);
		MessageBox(test,_T("Error"),NULL);
		Result=Close_Com((unsigned char)m_ComPort);
	}
}

void CMy7565_VCDemoDlg::OnBUTTONCloseCOM() 
{
	// TODO: Add your control notification handler code here
	BOOL Result;

	KillTimer(200);

	m_BtnOpenCom.EnableWindow(true);
	m_BtnCloseCom.EnableWindow(false);
	m_ComboComPort.EnableWindow(true);
	m_ComboBaudrate.EnableWindow(true);
	m_ComboDataBit.EnableWindow(true);
	m_ComboParity.EnableWindow(true);
	m_ComboStopBit.EnableWindow(true);
	
	m_CheckBoxUseCAN.EnableWindow(false);
	m_auto.EnableWindow(false);
	m_stop.EnableWindow(false);
	m_send.EnableWindow(false);
	m_SetTimer.EnableWindow(false);
	m_EditSendMsg.EnableWindow(false);

	m_mode.EnableWindow(false);
	m_id.EnableWindow(false);
	m_rtr.EnableWindow(false);
	m_dlen.EnableWindow(false);
	m_d0.EnableWindow(false);
	m_d1.EnableWindow(false);
	m_d2.EnableWindow(false);
	m_d3.EnableWindow(false);
	m_d4.EnableWindow(false);
	m_d5.EnableWindow(false);
	m_d6.EnableWindow(false);
	m_d7.EnableWindow(false);
	m_timer.EnableWindow(false);
	m_Clear.EnableWindow(false);
	m_stoprece.EnableWindow(false);
	m_startrece.EnableWindow(false);
	m_radio_scroll->EnableWindow(false);

	if(OpenCOMFlag == 1)
	{
		SuspendThread(TimerHandle);
		SuspendThread(AnalyzeHandle);
	}

	OpenCOMFlag=0;

	Sleep(500);
	Result=Close_Com((unsigned char)m_ComPort);

	ResponseIdx=0;
}

void CMy7565_VCDemoDlg::OnSelchangeCombo1() 
{
	// TODO: Add your control notification handler code here
	switch(m_ComboComPort.GetCurSel()){
		case 0:
			m_ComPort=1;
			break;
		case 1:
			m_ComPort=2;
			break;
		case 2:
			m_ComPort=3;
			break;
		case 3:
			m_ComPort=4;
			break;
		case 4:
			m_ComPort=5;
			break;
		case 5:
			m_ComPort=6;
			break;
		case 6:
			m_ComPort=7;
			break;
		case 7:
			m_ComPort=8;
			break;
		case 8:
			m_ComPort=9;
			break;
		case 9:
			m_ComPort=10;
			break;
		case 10:
			m_ComPort=11;
			break;
		case 11:
			m_ComPort=12;
			break;
		case 12:
			m_ComPort=13;
			break;
		case 13:
			m_ComPort=14;
			break;
		case 14:
			m_ComPort=15;
			break;
	}
}

void CMy7565_VCDemoDlg::OnSelchangeCombo2() 
{
	// TODO: Add your control notification handler code here
	switch(m_ComboBaudrate.GetCurSel()){
		case 0:
			m_Baudrate=1200;
			break;
		case 1:
			m_Baudrate=2400;
			break;
		case 2:
			m_Baudrate=4800;
			break;
		case 3:
			m_Baudrate=9600;
			break;
		case 4:
			m_Baudrate=19200L;
			break;
		case 5:
			m_Baudrate=38400L;
			break;
		case 6:
			m_Baudrate=57600L;
			break;
		case 7:
			m_Baudrate=115200L;
			break;
		case 8:
			m_Baudrate=230400L;
			break;
		case 9:
			m_Baudrate=460800L;
			break;
		case 10:
			m_Baudrate=921600L;
			break;
	}
}

void CMy7565_VCDemoDlg::OnSelchangeCombo3() 
{
	// TODO: Add your control notification handler code here
	switch(m_ComboDataBit.GetCurSel()){
		case 0:
			m_DataBit=5;
			break;
		case 1:
			m_DataBit=6;
			break;
		case 2:
			m_DataBit=7;
			break;
		case 3:
			m_DataBit=8;
			break;
	}
}

void CMy7565_VCDemoDlg::OnSelchangeCombo4() 
{
	// TODO: Add your control notification handler code here
	m_Parity = m_ComboParity.GetCurSel();
}

void CMy7565_VCDemoDlg::OnSelchangeCombo5() 
{
	// TODO: Add your control notification handler code here
	switch(m_ComboStopBit.GetCurSel()){
		case 0:
			m_StopBit=1;
			break;
		case 1:
			m_StopBit=2;
	}
}

void CMy7565_VCDemoDlg::OnButtonClear() 
{
	// TODO: Add your control notification handler code here
	if(OpenCOMFlag)
	{	
		ClearList = 1;
	}
	else
	{
		ms_ReceiveList->Clear();
		SetTextMatrix();
		ms_ReceiveList->SetTopRow(1);
		MesgCount = 0;
	}
}

void CMy7565_VCDemoDlg::OnButtonStoprece() 
{
	// TODO: Add your control notification handler code here
	m_stoprece.ShowWindow(SW_HIDE);
	m_startrece.ShowWindow(SW_SHOW);
	SuspendThread(TimerHandle);
	SuspendThread(AnalyzeHandle);
}

void CMy7565_VCDemoDlg::OnButtonStartrece() 
{
	// TODO: Add your control notification handler code here
	m_stoprece.ShowWindow(SW_SHOW);
	m_startrece.ShowWindow(SW_HIDE);
	ResumeThread(TimerHandle);
	ResumeThread(AnalyzeHandle);
}


void CMy7565_VCDemoDlg::OnCHECKUseCAN() 
{
	// TODO: Add your control notification handler code here
	m_CheckUseCAN = m_CheckBoxUseCAN.GetCheck();

	if(m_CheckUseCAN == 0)
	{
		m_EditSendMsg.EnableWindow(true);
		m_mode.EnableWindow(false);
		m_id.EnableWindow(false);
		m_rtr.EnableWindow(false);
		m_dlen.EnableWindow(false);
		m_d0.EnableWindow(false);
		m_d1.EnableWindow(false);
		m_d2.EnableWindow(false);
		m_d3.EnableWindow(false);
		m_d4.EnableWindow(false);
		m_d5.EnableWindow(false);
		m_d6.EnableWindow(false);
		m_d7.EnableWindow(false);
	}
	else if(m_CheckUseCAN == 1)
	{
		m_EditSendMsg.EnableWindow(false);
		m_mode.EnableWindow(true);
		m_id.EnableWindow(true);
		m_rtr.EnableWindow(true);
		m_dlen.EnableWindow(true);
		m_d0.EnableWindow(true);
		m_d1.EnableWindow(true);
		m_d2.EnableWindow(true);
		m_d3.EnableWindow(true);
		m_d4.EnableWindow(true);
		m_d5.EnableWindow(true);
		m_d6.EnableWindow(true);
		m_d7.EnableWindow(true);

		CallBackToCEdit(13);
	}
}

void CMy7565_VCDemoDlg::OnBUTTONSend() 
{
	// TODO: Add your control notification handler code here
	WORD Result;

	memset(m_szSend, '\0', 40);

	m_EditSendMsg.GetWindowText(m_szSend,40);  

	Result=Send_Cmd((unsigned char)m_ComPort, m_szSend,0);

}

void CMy7565_VCDemoDlg::CallBackToCEdit(int Index)
{
	char temp1[10],temp2[10],temp3[40];
	char* endtemp;
	unsigned long ltemp1,ltemp2;

	if(Index == -1){
		m_mode.SetWindowText("0");
		m_id.SetWindowText("0");
		m_rtr.SetWindowText("0");
		m_dlen.SetWindowText("0");
		m_d0.SetWindowText("00");
		m_d1.SetWindowText("00");
		m_d2.SetWindowText("00");
		m_d3.SetWindowText("00");
		m_d4.SetWindowText("00");
		m_d5.SetWindowText("00");
		m_d6.SetWindowText("00");
		m_d7.SetWindowText("00");
		m_EditSendMsg.SetWindowText("t0000");
	}
	else
	{
		memset(temp1, '\0', sizeof(temp1));
		memset(temp2, '\0', sizeof(temp2));
		memset(temp3, '\0', sizeof(temp3));
		//CAN Mode
		m_mode.GetWindowText(temp1,20);
		m_rtr.GetWindowText(temp2,20);
		ltemp1 = strtol(temp1,&endtemp,16);
		ltemp2 = strtol(temp2,&endtemp,16);
		if(ltemp1 == 0)
		{
			if(ltemp2 == 0)	temp3[0]='t';
			else	temp3[0]='T';

			//CAN ID
			m_id.GetWindowText(temp1,20);
			sprintf(temp3,"%c%03X",temp3[0],strtol(temp1,&endtemp,16)&0x7FF);
			ltemp2=5;
		}
		else
		{
			if(ltemp2 == 0)	temp3[0]='e';
			else	temp3[0]='E';
		
			//CAN ID
			m_id.GetWindowText(temp1,20);
			sprintf(temp3,"%c%08lX",temp3[0],strtol(temp1,&endtemp,16)&0x1FFFFFFF);

			ltemp2=10;
		}
		
		//CAN DLEN
		memset(temp1, '\0', sizeof(temp1));
		m_dlen.GetWindowText(temp1,20);
		sprintf(temp3,"%s%s",temp3,temp1);
		ltemp1 = strtol(temp1,&endtemp,16);
		
		//CAN Data
		for(ltemp2=0;ltemp2<ltemp1;ltemp2++)
		{
			memset(temp1, '\0', sizeof(temp1));
			switch(ltemp2)
			{
				case 0:
					m_d0.GetWindowText(temp1,5);
					sprintf(temp3,"%s%02X",temp3,strtol(temp1,&endtemp,16)&0xFF);
				break;
				case 1:
					m_d1.GetWindowText(temp1,5);
					sprintf(temp3,"%s%02X",temp3,strtol(temp1,&endtemp,16)&0xFF);
				break;
				case 2:
					m_d2.GetWindowText(temp1,5);
					sprintf(temp3,"%s%02X",temp3,strtol(temp1,&endtemp,16)&0xFF);
				break;
				case 3:
					m_d3.GetWindowText(temp1,5);
					sprintf(temp3,"%s%02X",temp3,strtol(temp1,&endtemp,16)&0xFF);
				break;
				case 4:
					m_d4.GetWindowText(temp1,5);
					sprintf(temp3,"%s%02X",temp3,strtol(temp1,&endtemp,16)&0xFF);
				break;
				case 5:
					m_d5.GetWindowText(temp1,5);
					sprintf(temp3,"%s%02X",temp3,strtol(temp1,&endtemp,16)&0xFF);
				break;
				case 6:
					m_d6.GetWindowText(temp1,5);
					sprintf(temp3,"%s%02X",temp3,strtol(temp1,&endtemp,16)&0xFF);
				break;
				case 7:
					m_d7.GetWindowText(temp1,5);
					sprintf(temp3,"%s%02X",temp3,strtol(temp1,&endtemp,16)&0xFF);
				break;
			}
		}

		m_EditSendMsg.SetWindowText(temp3);
	}
	return;
}

void CMy7565_VCDemoDlg::OnChangeEditMode() 
{
	CallBackToCEdit(1);
}

void CMy7565_VCDemoDlg::OnChangeEditId() 
{
	CallBackToCEdit(2);
}

void CMy7565_VCDemoDlg::OnChangeEditRtr() 
{
	CallBackToCEdit(3);
}

void CMy7565_VCDemoDlg::OnChangeEditDlen() 
{
	CallBackToCEdit(4);
}

void CMy7565_VCDemoDlg::OnChangeEditD0() 
{
	CallBackToCEdit(5);
}

void CMy7565_VCDemoDlg::OnChangeEditD1() 
{
	CallBackToCEdit(6);
}

void CMy7565_VCDemoDlg::OnChangeEditD2() 
{
	CallBackToCEdit(7);
}

void CMy7565_VCDemoDlg::OnChangeEditD3() 
{
	CallBackToCEdit(8);
}

void CMy7565_VCDemoDlg::OnChangeEditD4() 
{
	CallBackToCEdit(9);
}

void CMy7565_VCDemoDlg::OnChangeEditD5() 
{
	CallBackToCEdit(10);
}

void CMy7565_VCDemoDlg::OnChangeEditD6() 
{
	CallBackToCEdit(11);
}

void CMy7565_VCDemoDlg::OnChangeEditD7() 
{
	CallBackToCEdit(12);
}


void CMy7565_VCDemoDlg::OnBUTTONAuto() 
{
	// TODO: Add your control notification handler code here
	SetTimer(200, m_timerint, NULL);
	m_auto.EnableWindow(FALSE);
	m_stop.EnableWindow(TRUE);
}

void CMy7565_VCDemoDlg::OnBUTTONStop() 
{
	// TODO: Add your control notification handler code here

	KillTimer(200);
	m_auto.EnableWindow(TRUE);
	m_stop.EnableWindow(FALSE);
}

void CMy7565_VCDemoDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if(nIDEvent==200)
		OnBUTTONSend();

	CDialog::OnTimer(nIDEvent);
}


void CMy7565_VCDemoDlg::OnBUTTONSet() 
{
	// TODO: Add your control notification handler code here
	char temp[20], *endptr;

	KillTimer(200);
	m_auto.EnableWindow(TRUE);
	m_stop.EnableWindow(FALSE);

	m_timer.GetWindowText(temp,5);
	m_timerint=strtol(temp,&endptr,10)&0xFFFF;
}

void CMy7565_VCDemoDlg::OnRadioScroll() 
{
	// TODO: Add your control notification handler code here
	Scrolling = m_radio_scroll->GetCheck();
}
